"""
This type stub file was generated by pyright.
"""

from .std import tqdm as std_tqdm

"""
Tkinter GUI progressbar decorator for iterators.

Usage:
>>> from tqdm.tk import trange, tqdm
>>> for i in trange(10):
...     ...
"""
__author__ = ...
__all__ = ['tqdm_tk', 'ttkrange', 'tqdm', 'trange']
class tqdm_tk(std_tqdm):
    """
    Experimental Tkinter GUI version of tqdm!

    Note: Window interactivity suffers if `tqdm_tk` is not running within
    a Tkinter mainloop and values are generated infrequently. In this case,
    consider calling `tqdm_tk.refresh()` frequently in the Tk thread.
    """
    def __init__(self, *args, **kwargs) -> None:
        """
        This class accepts the following parameters *in addition* to
        the parameters accepted by `tqdm`.

        Parameters
        ----------
        grab  : bool, optional
            Grab the input across all windows of the process.
        tk_parent  : `tkinter.Wm`, optional
            Parent Tk window.
        cancel_callback  : Callable, optional
            Create a cancel button and set `cancel_callback` to be called
            when the cancel or window close button is clicked.
        """
        ...
    
    def close(self): # -> None:
        ...
    
    def clear(self, *_, **__): # -> None:
        ...
    
    def display(self, *_, **__): # -> None:
        ...
    
    def set_description(self, desc=..., refresh=...): # -> None:
        ...
    
    def set_description_str(self, desc=..., refresh=...): # -> None:
        ...
    
    def cancel(self): # -> None:
        """
        `cancel_callback()` followed by `close()`
        when close/cancel buttons clicked.
        """
        ...
    
    def reset(self, total=...): # -> None:
        """
        Resets to 0 iterations for repeated use.

        Parameters
        ----------
        total  : int or float, optional. Total to use for the new bar.
        """
        ...
    


def ttkrange(*args, **kwargs): # -> tqdm_tk:
    """
    A shortcut for `tqdm.tk.tqdm(xrange(*args), **kwargs)`.
    On Python3+, `range` is used instead of `xrange`.
    """
    ...

tqdm = tqdm_tk
trange = ...
